<TeXmacs|1.0.7.14>

<style|<tuple|beamer|mathemagix|vdh>>

<\body>
  <screens|<\shown>
    <\with|par-mode|center>
      <strong|<\with|font-base-size|17>
        Multi-precision computations & high performance<new-line><small|A
        delicate marriage>
      </with>>

      <abbr|Joris> van der Hoeven<new-line><small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Bangalore,
      2011<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|The silly remark not to make>

    \;

    <unroll|<\shown>
      ``We already lack precision in our input data. Why use multiple
      precision?''
    </shown>|<\hidden>
      \;

      ``Does the Navier-Stokes equation change when you modify your input
      data?''
    </hidden>|<\hidden>
      \;

      ``Does the nature of a solution to NS change if you (slightly) modify
      your input data?''
    </hidden>|<\hidden>
      \;

      ``Why not perform all computations using <math|8> bits of precision?''
    </hidden>>
  </hidden>|<\hidden>
    <tit|When do we need multiple precision arithmetic?>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|Large condition numbers>

      Condition number <math|\<kappa\>\<geqslant\>2<rsup|52>> implies double
      precision arithmetic makes no sense
    </shown>|<\hidden>
      <vspace*|0.5fn><strong|Example:> Inversion of a matrix <math|M> with

      <\equation*>
        \<kappa\><around*|(|M|)>=<around*|\<\|\|\>|M|\<\|\|\>>*<around*|\<\|\|\>|M<rsup|-1>|\<\|\|\>>\<geqslant\>2<rsup|52>
      </equation*>
    </hidden>|<\hidden>
      <vspace*|0.5fn><strong|Example:> integration of a dynamical system
      <math|Y<rprime|'>=\<Phi\><around*|(|Y|)>,Y<around*|(|0|)>=C> near a
      singularity <math|\<sigma\>>

      <\equation*>
        \<kappa\><around*|(|<frac|\<partial\>
        Y<around*|(|\<sigma\>-\<varepsilon\>|)>|\<partial\>
        C>|)>\<geqslant\>2<rsup|52>
      </equation*>
    </hidden>>
  </hidden>|<\hidden>
    <tit|When do we need multiple precision arithmetic?>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|Beyond condition numbers>

      <with|color|dark blue|Problem:> compute some real number with a
      relative error <math|\<varepsilon\>\<gtr\>0>
    </shown>|<\hidden>
      <with|color|dark blue|Classical:> pick precision <math|p> with
      <math|\<kappa\>*2<rsup|-p>\<leqslant\>\<varepsilon\>>, that is
      <math|p\<geqslant\>\<phi\><around*|(|p<rsub|\<varepsilon\>>|)>=p<rsub|\<varepsilon\>>+log<rsub|2>
      \<kappa\>> with <math|p<rsub|\<varepsilon\>>=log<rsub|2>
      <frac|1|\<varepsilon\>>>
    </hidden>|<\hidden>
      <with|color|dark blue|Non-classical:> we need
      <math|p\<geqslant\>c*p<rsub|\<varepsilon\>>> with <math|c\<gtr\>1> or
      even <math|p\<geqslant\>p<rsub|\<varepsilon\>><rsup|c>> with
      <math|c\<gtr\>1>
    </hidden>|<\hidden>
      <vspace*|0.5fn><strong|Asymptotic extrapolation> for a favourable
      sequence <math|f<rsub|n>> with

      <\equation*>
        f<rsub|n>\<approx\>\<alpha\><rsup|n>*<around*|(|<frac|a<rsub|0>*log
        n+b<rsub|0>|n<rsup|0>>+<frac|a<rsub|1>*log
        n+b<rsub|1>|n<rsup|1>>+<frac|a<rsub|2>*log
        n+b<rsub|2>|n<rsup|2>>+\<cdots\>|)>
      </equation*>

      <with|color|dark blue|Problem:> cost to determine <math|\<alpha\>> with
      relative error <math|\<varepsilon\>\<gtr\>0>?

      Compute <math|f<rsub|0>,\<ldots\>,f<rsub|N>>
    </hidden>|<\hidden>
      <tabular|<tformat|<cwith|1|1|1|1|cell-lsep|0ln>|<table|<row|<cell|<with|color|dark
      blue|Analysis:>>|<cell|computation of
      <math|\<alpha\>,a<rsub|0>,b<rsub|0,>\<ldots\>,a<rsub|k-1>,b<rsub|k-1>>
      yields <math|\<alpha\>> with relative error
      <math|\<approx\>N<rsup|-k>>>>|<row|<cell|>|<cell|However: we need a
      precision <math|p> with <math|2<rsup|-p>\<lessapprox\>N<rsup|-2*k>>,
      <abbr|i.e.> <math|p\<geqslant\>2*p<rsub|\<varepsilon\>>+o<around*|(|p<rsub|\<varepsilon\>>|)>>>>|<row|<cell|>|<cell|Choice
      of <math|N>: depends and to be analyzed in detail>>>>>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Mathematical simulations>

    \;

    <\granite>
      <\remark*>
        Multiple precision computations can be particularly useful in order
        to ``simulate'' an equation with simple exact mathematical boundary
        conditions.
      </remark*>
    </granite>

    \;
  </hidden>|<\hidden>
    <htab|5mm><with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|0.707125cm|<tuple|0.0671212gw|0.0382469gh>>|gr-geometry|<tuple|geometry|0.550079par|0.699379par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|magnify|0.707106780759852|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<point|6.6|13.4>|<point|7|14>|<point|7.6|14.8>|<point|8|15.5>|<point|8.6|16.3>|<point|9|17>|<point|9.6|17.8>|<point|10|18.4>|<point|10.6|19.2>|<point|11|19.9>|<point|11.6|20.7>|<point|12|21.3>|<with|color|blue|<point|0|3.7>>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|13|<point|-0.3|13>>>|<with|text-at-halign|right|<math-at|14|<point|-0.3|14>>>|<with|text-at-halign|right|<math-at|15|<point|-0.3|15>>>|<with|text-at-halign|right|<math-at|16|<point|-0.3|16>>>|<with|text-at-halign|right|<math-at|17|<point|-0.3|17>>>|<with|text-at-halign|right|<math-at|18|<point|-0.3|18>>>|<with|text-at-halign|right|<math-at|19|<point|-0.3|19>>>|<with|text-at-halign|right|<math-at|20|<point|-0.3|20>>>|<with|text-at-halign|right|<math-at|21|<point|-0.3|21>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|6|<point|0|-0.5>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.0|9.6>>|<with|color|blue|<point|3.6|9.1>>|<with|color|blue|<point|3.0|7.8>>|<with|color|blue|<point|2.6|7.2>>|<with|color|blue|<point|2.0|6.4>>|<with|color|blue|<point|1.6|6.2>>|<with|color|blue|<point|1.0|5.3>>|<with|color|blue|<point|4.6|10.3>>|<with|color|blue|<point|5.0|11.1>>|<with|color|blue|<point|5.6|11.9>>|<text-at|log
    in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
    overhead|<point|0.5|20>>|<point|5.5|7.0>|<text-at|Overhead of multiple
    precision arithmetic|<point|6.0|7.0>>|<with|color|blue|<point|5.5|6.0>>|<with|color|blue|<text-at|Overhead
    of mantissa arithmetic|<point|6.0|6.0>>>|<text-at|MPFR with respect to
    ``double''|<point|6|5>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|How to implement multiple precision arithmetic?>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|What the hardware provides>

      <\compact>
        <unroll|<\shown>
          195*, 196*, 197*: software implementation of floating point
          arithmetic
        </shown>|<\hidden>
          198*, 199*: mathematical co-processors, single precision, later
          double precision
        </hidden>|<\hidden>
          200*: single and double precision IEEE arithmetic, integer
          arithmetic, GPUs
        </hidden>|<\hidden>
          201*: single, double, quadruple precision FP and integer
          arithmetic, wide SIMD, GPUs
        </hidden>>
      </compact>
    </shown>|<\hidden>
      <strong|Software implementation, strategy I>

      <\compact>
        Use built-in floating point arithmetic

        <switch|<\shown>
          \;
        </shown>|<\hidden>
          Problem: hardware implementation of three sum
        </hidden>|<\hidden>
          Question: will CPU manufacturers help us?
        </hidden>|<\hidden>
          Question: will CPU manufacturers help us?

          Answer: no, unless turbulence will be interesting for computer
          games
        </hidden>>
      </compact>
    </hidden>|<\hidden>
      <strong|Software implementation, strategy II>

      <\compact>
        <unroll|<\shown>
          Use built-in integer arithmetic as in MPFR library
        </shown>|<\hidden>
          Problem 1: overhead for emulation of exponents
        </hidden>|<\hidden>
          Problem 2: overhead for emulation of signs
        </hidden>|<\hidden>
          Problem 3: overhead for emulation of correct rounding
        </hidden>|<\hidden>
          Problem 4: overhead for emulation of exceptions
        </hidden>>
      </compact>
    </hidden>>

    \;
  </hidden>|<\hidden>
    <tit|Using built-in floating point arithmetic>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|Correct rounding>

      <htab|5mm><with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1cm|<tuple|-0.659999gw|0.499999gh>>|gr-geometry|<tuple|geometry|0.429552par|0.131938par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|3|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|3|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|3|#e0e0ff>>|gr-text-at-valign|center|gr-color|red|<graphics||<point|11|0>|<point|10|0>|<point|9|0>|<point|12|0>|<math-at|1.0101010110|<point|11|-1>>|<with|text-at-halign|right|<math-at|1.0101010101|<point|10|-1>>>|<with|color|red|<point|10.3333333333333|0.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<cdots\>|<point|13|0>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<cdots\>|<point|8|0>>>|<line|<point|10|0>|<point|8.32395158089694|-0.424543590422013>>|<line|<point|11|0>|<point|12.6760318825241|-0.424543590422013>>|<with|text-at-valign|center|text-at-halign|center|<math-at|4/3|<point|10.3333|1>>>|<with|color|red|<line|<point|10.3333|0>|<point|10.3332947479825|0.510285752083609>>>>><htab|5mm>
    </shown>|<\hidden>
      <strong|Fused multiply subtract>

      <\compact>
        <unroll|<\shown>
          Problem: exact multiplication of <math|x,y\<in\>\<bbb-F\><rsub|52>>
          as <math|x*y=h+l\<in\>\<bbb-F\><rsub|104>> with
          <math|h,l\<in\>\<bbb-F\><rsub|52>>
        </shown>|<\hidden>
          Solution: <math|h\<assign\><around*|(|x\<times\>y|)><rsub|\<bbb-F\><rsub|52>>>,
          <math|l\<assign\><around*|(|x\<times\>y-h|)><rsub|\<bbb-F\><rsub|52>>>
        </hidden>>
      </compact>
    </hidden>|<\hidden>
      <vspace*|0.5fn><strong|Three sum (fused add subtract)>

      Similar operation for addition: <math|h\<assign\><around*|(|x+y|)><rsub|\<bbb-F\><rsub|52>>>,
      <math|l\<assign\><around*|(|x+y-h|)><rsub|\<bbb-F\><rsub|52>>>
    </hidden>|<\hidden>
      <vspace*|0.5fn><strong|Exercise>

      Design multiple precision arithmetic using these operations
    </hidden>>
  </hidden>|<\hidden>
    <tit|Using built-in integer arithmetic>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|MPFR library>

      Represent mantissas by GMP integers (with separate field for signs)
    </shown>|<\hidden>
      <vspace*|0.5fn><strong|Unsigned fixed point arithmetic>

      <math|X\<in\><around*|{|0,\<ldots\>,2<rsup|p>-1|}>> represents
      <math|x=X*2<rsup|-p>>

      Multiplication at precision <math|2*p>:

      <htab|5mm><math|<around*|(|X<rsub|1>*2<rsup|p>+X<rsub|0>|)>*<around*|(|Y<rsub|1>*2<rsup|p>+Y<rsub|0>|)>*2<rsup|-4*p>=X<rsub|0>*X<rsub|1>*2<rsup|-2*p>+<around*|(|X<rsub|0>*Y<rsub|1>+X<rsub|1>*Y<rsub|0>|)>*2<rsup|-3*p>+\<cdots\>><htab|5mm>

      That is: three integer multiplications and four additions
    </hidden>|<\hidden>
      <strong|Signed fixed point arithmetic>

      <math|X\<in\><around*|{|0,\<ldots\>,2<rsup|p>-1|}>> represents
      <math|<wide|x|~>=X*2<rsup|-p>-<frac|1|2>>

      <\eqnarray*>
        <tformat|<table|<row|<cell|2*<wide|x|~>*<wide|y|~>+<tfrac|1|2>>|<cell|=>|<cell|2*x*y-<around*|(|x+y|)>+1>>>>
      </eqnarray*>

      Multiplication at precision <math|2*p>: six extra additions
    </hidden>>

    \;
  </hidden>|<\hidden>
    <tit|Moderate precision arithmetic>

    \;

    <htab|5mm><block*|<tformat|<cwith|1|-1|1|-1|cell-width|5em>|<cwith|1|-1|1|-1|cell-hmode|exact>|<table|<row|<cell|Precision>|<cell|Unsigned>|<cell|Signed>|<cell|Multipl.>>|<row|<cell|<math|p>>|<cell|<math|1>>|<cell|<math|2>>|<cell|<math|1>>>|<row|<cell|<math|2*p>>|<cell|<math|7>>|<cell|<math|13>>|<cell|<math|3>>>|<row|<cell|<math|3*p>>|<cell|<math|12>>|<cell|<math|21>>|<cell|<math|6>>>|<row|<cell|<math|4*p>>|<cell|<math|18>>|<cell|<math|30>>|<cell|<math|10>>>|<row|<cell|<math|5*p>>|<cell|<math|25>>|<cell|<math|40>>|<cell|<math|15>>>|<row|<cell|<math|6*p>>|<cell|<math|33>>|<cell|<math|51>>|<cell|<math|21>>>|<row|<cell|<math|7*p>>|<cell|<math|42>>|<cell|<math|63>>|<cell|<math|28>>>|<row|<cell|<math|8*p>>|<cell|<math|52>>|<cell|<math|76>>|<cell|<math|36>>>>>><htab|5mm>

    \;
  </hidden>|<\hidden>
    <htab|5mm><with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|0.707181cm|<tuple|0.0642831gw|0.0446042gh>>|gr-geometry|<tuple|geometry|0.537035par|0.699376par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-color|red|magnify|0.707106780759852|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<point|6.6|13.4>|<point|7|14>|<point|7.6|14.8>|<point|8|15.5>|<point|8.6|16.3>|<point|9|17>|<point|9.6|17.8>|<point|10|18.4>|<point|10.6|19.2>|<point|11|19.9>|<point|11.6|20.7>|<point|12|21.3>|<with|color|blue|<point|0|3.7>>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|13|<point|-0.3|13>>>|<with|text-at-halign|right|<math-at|14|<point|-0.3|14>>>|<with|text-at-halign|right|<math-at|15|<point|-0.3|15>>>|<with|text-at-halign|right|<math-at|16|<point|-0.3|16>>>|<with|text-at-halign|right|<math-at|17|<point|-0.3|17>>>|<with|text-at-halign|right|<math-at|18|<point|-0.3|18>>>|<with|text-at-halign|right|<math-at|19|<point|-0.3|19>>>|<with|text-at-halign|right|<math-at|20|<point|-0.3|20>>>|<with|text-at-halign|right|<math-at|21|<point|-0.3|21>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|6|<point|0|-0.5>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.0|9.6>>|<with|color|blue|<point|3.6|9.1>>|<with|color|blue|<point|3.0|7.8>>|<with|color|blue|<point|2.6|7.2>>|<with|color|blue|<point|2.0|6.4>>|<with|color|blue|<point|1.6|6.2>>|<with|color|blue|<point|1.0|5.3>>|<with|color|blue|<point|4.6|10.3>>|<with|color|blue|<point|5.0|11.1>>|<with|color|blue|<point|5.6|11.9>>|<text-at|log
    in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
    overhead|<point|0.5|20>>|<text-at|Overhead of MPFR
    arithmetic|<point|6.0|7.0>>|<with|color|blue|<text-at|Overhead of MPFR
    mantissa arithmetic|<point|6.0|6.0>>>|<with|color|red|<point|1|3.7>>|<with|color|red|<point|0.0|1.0>>|<with|color|red|<point|2.0|4.9>>|<with|color|red|<point|1.6|4.4>>|<with|color|red|<point|2.6|5.6>>|<with|color|red|<point|3|6.2>>|<with|color|red|<point|3.6|7.1>>|<with|color|red|<point|4.0|7.8>>|<with|color|red|<point|4.6|8.8>>|<with|color|red|<point|5|9.4>>|<with|color|red|<point|5.6|10.5>>|<with|color|red|<point|6|11.2>>|<with|color|red|<point|6.6|12.3>>|<with|color|red|<point|7|13.1366>>|<with|color|red|<point|7.6|14.3>>|<with|color|red|<point|8|15.1>>|<with|color|red|<point|8.6|16.2>>|<with|color|blue|<point|5.5|6.25>>|<point|5.5|7.25>|<with|color|red|<point|5.5|5.25>>|<with|color|red|<text-at|Overhead
    of signed fixed point arithmetic|<point|6|5>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Rethinking scientific computation>

    \;

    <unroll|<\shown>
      <strong|Challenge 0:> for what kind of problems do we need multiple
      precision arithmetic?
    </shown>|<\hidden>
      <strong|Challenge 1:> rethink numerical analysis from the multiple
      precision perspective
    </hidden>|<\hidden>
      <strong|Challenge 2:> rethink numerical algorithms together with the
      underlying arithmetic
    </hidden>|<\hidden>
      <strong|Challenge 3:> rethink compilers for automatic code generation
      of non trivial arithmetic
    </hidden>|<\hidden>
      <strong|Challenge 4:> how to benefit from massively parallel
      architectures?
    </hidden>|<\hidden>
      <strong|Challenge 5:> how to incorporate automatic computation of error
      bounds?
    </hidden>|<\hidden>
      <strong|Challenge 6:> how to interface with symbolic computation?
    </hidden>>

    \;
  </hidden>|<\hidden>
    <tit|Fast Fourier transforms>

    \;

    <unroll|<\shown>
      <strong|Claim:> we can do all our computations using the signed fixed
      point representation
    </shown>|<\hidden>
      \;

      <strong|Indeed:>

      <\itemize>
        <item>Assume that we want to transform
        <math|a<rsub|0>,\<ldots\>,a<rsub|n-1>> with <math|n=2<rsup|k>>

        <item>Write <math|b<rsub|i>=<dfrac|a<rsub|i>|2*n*<around*|\<\|\|\>|a|\<\|\|\>>>>
        with <math|<around*|\<\|\|\>|a|\<\|\|\>>=max<rsub|i>
        <around*|\||a<rsub|i>|\|>>, so that
        <math|<wide|a|^><rsub|i>=2*n*<around*|\<\|\|\>|a|\<\|\|\>>*<wide|b|^><rsub|i>>

        <item>Then all numbers occurring in the FFT are in
        <math|<around*|[|-<frac|1|2>,<frac|1|2>|]>>
      </itemize>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Dynamical systems near singularities>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|The system to integrate>

      <\eqnarray*>
        <tformat|<table|<row|<cell|Y<rprime|'>>|<cell|=>|<cell|\<Phi\><around*|(|Y|)>>>|<row|<cell|Y<around*|(|0|)>>|<cell|=>|<cell|C>>>>
      </eqnarray*>
    </shown>|<\hidden>
      <strong|Power series solution>

      <\eqnarray*>
        <tformat|<table|<row|<cell|Y<around*|(|z|)>>|<cell|=>|<cell|<big|sum><rsub|k=0><rsup|\<infty\>>Y<rsub|k>*z<rsup|k>>>>>
      </eqnarray*>
    </hidden>|<\hidden>
      <strong|Preconditioning for signed fixed point arithmetic>

      <\eqnarray*>
        <tformat|<table|<row|<cell|Y<around*|(|z|)>>|<cell|=>|<cell|<wide|Y|~><around*|(|\<varrho\>*z|)>>>|<row|<cell|<wide|Y|~><rprime|'>>|<cell|=>|<cell|\<varrho\>*\<Phi\><around*|(|<wide|Y|~>|)>>>>>
      </eqnarray*>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Blasius equation>

    <htab|5mm><image|blasius.png|0.9par|||><htab|5mm>
  </hidden>|<\hidden>
    <tit|Chazy equation>

    <htab|5mm><image|chazy.png|0.85par|||><htab|5mm>

    \;
  </hidden>|<\hidden>
    <tit|Matrix multiplication over <math|\<bbb-Z\>>>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|Problem>

      Given <math|M,N\<in\>\<bbb-Z\><rsub|;p><rsup|n\<times\>n>>,
      <math|\<bbb-Z\><rsub|;p>=<around*|{|-2<rsup|p-1>,\<ldots\>,0,\<ldots\>,2<rsup|p-1>-1|}>>,
      compute <math|M*N>
    </shown>|<\hidden>
      <vspace*|0.5fn><strong|Chinese remaindering when <math|p\<ll\>n>>

      <\compact>
        <\itemize>
          <item>Pick primes <math|q<rsub|1>,\<ldots\>,q<rsub|l>> with
          <math|q<rsub|1>*\<cdots\>*q<rsub|l>\<gtr\>n*2<rsup|p>>

          <item>Reduce <math|M> and <math|N> modulo <math|q<rsub|i>> for each
          <math|i> (<math|O<around*|(|n<rsup|2>*p*log p*log log p|)>>
          operations)

          <item>Multiply <math|<around*|(|M*N mod q<rsub|i>|)>=<around*|(|M
          mod q<rsub|i>|)>*<around*|(|N mod q<rsub|i>|)>> for each <math|i>
          (<math|O<around*|(|n<rsup|3>*p|)>> operations)

          <item>Reconstruct <math|M*N> from the <math|M*N mod q<rsub|i>>
          (<math|O<around*|(|n<rsup|2>*p*log<rsup|2> p*log log p|)>>
          operations)
        </itemize>
      </compact>
    </hidden>|<\hidden>
      <vspace*|0.5fn><strong|FFT over a finite field <math|\<bbb-F\><rsub|q>>
      when <math|p<space|0.6spc>\<nll\><space|0.6spc>n>>

      <\compact>
        <\itemize>
          <item>Pick <math|q=3\<times\>2<rsup|30>+1> and <math|\<omega\>=125>
          with <math|\<omega\><rsup|2<rsup|29>>=-1> in
          <math|\<bbb-F\><rsub|q>>

          <item>Write integers in base <math|2<rsup|k>> with
          <math|n*2<rsup|2*k>\<less\>q>, <abbr|i.e.> as evaluations
          <math|P<around*|(|2<rsup|k>|)>>,
          <math|P\<in\>\<bbb-Z\><rsub|;k><around*|[|2<rsup|k>|]>>

          <item>Compute products of polynomials
          <math|P,Q\<in\>\<bbb-Z\><rsub|;k><around*|[|2<rsup|k>|]><rsup|n\<times\>n>>
          using FFT <abbr|w.r.t.> <math|\<omega\>> over
          <math|\<bbb-F\><rsub|q>>

          <item>Cost: <math|O<around*|(|n<rsup|2>*p*log p*log log
          p+n<rsup|3>*p|)>>
        </itemize>
      </compact>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Conclusion>

    \;

    <unroll|<\shown>
      Classical double precision methods are and will continue to be a
      powerful workhorse
    </shown>|<\hidden>
      \;

      But
    </hidden>|<\hidden>
      <\compact>
        <\itemize>
          <unroll|<\shown>
            <item><strong|If> you are curious
          </shown>|<\hidden>
            <item><strong|If> you have time and energy
          </hidden>|<\hidden>
            <item><strong|If> you are good at programming
          </hidden>|<\hidden>
            <item><strong|If> you are sufficiently subversive
          </hidden>>
        </itemize>
      </compact>
    </hidden>|<\hidden>
      Then you may try and help developing multiple precision methods
    </hidden>|<\hidden>
      \;

      <\compact>
        Also: no need for a complete theory or big computers

        one can start building useful basic libraries for FFT, linear
        algebra, ...
      </compact>
    </hidden>>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|12>
    <associate|info-flag|none>
    <associate|magnification|1.4>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-height|757760unit>
    <associate|page-medium|automatic>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-screen-bot|5mm>
    <associate|page-screen-height|840960tmpt>
    <associate|page-screen-top|5mm>
    <associate|page-screen-width|1280000tmpt>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|page-width|1015808unit>
    <associate|preamble|false>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|wrap-fig|<tuple|?|?>>
  </collection>
</references>